VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "StrPtr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'O[õbN
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long

'O[obN
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long

'O[omۂ
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long

'O[oJ
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMen As Long) As Long

'Rs[
Private Declare Function lstrcpy Lib "kernel32" (ByVal lpString1 As Long, ByVal lpString2 As String) As Long

Private Const GHND = &H42

Private m_hGlobal As Long
Private m_hLockStrPtr As Long

Public Property Let Text(ByVal SrcText As String)
    
    '[
    Call FreeMemory

    'O[om
    m_hGlobal = GlobalAlloc(GHND, LenB(StrConv(SrcText, vbFromUnicode)) + 1)
    If m_hGlobal = 0 Then Debug.Print "GlobalAlloc Error!!": GoTo ErrHandler

    'O[obN
    m_hLockStrPtr = GlobalLock(m_hGlobal)
    If m_hLockStrPtr = 0 Then Debug.Print "GlobalLock Error!!": GoTo ErrHandler

    'Rs[
    Call lstrcpy(m_hLockStrPtr, SrcText)
    
    Exit Property

ErrHandler:
    Call FreeMemory
End Property


Public Property Get Ptr() As Long
    If m_hLockStrPtr Then Ptr = m_hLockStrPtr
End Property


Private Sub Class_Terminate()
    Call FreeMemory
End Sub


Private Sub FreeMemory()
    If m_hGlobal Then
        Call GlobalUnlock(m_hGlobal)
        Call GlobalFree(m_hGlobal)
        m_hGlobal = 0
        m_hLockStrPtr = 0
    End If
End Sub



